//
// bots, a screensaver by Howard Berkey
//


#include "CSaveThread.h"
#include "parseBots.h"

class weapon
{
public:
	static float speed; 
	static float range;
	BPoint m_pos;
	Robot *m_shooter;
	float m_speed;
	float m_dir; 
	int m_intensity;
	int m_decay; 
	void erase(BView *);
	void draw(BView *);
};


class RobotThread : public CSaveThread {
public:
	RobotThread();					
	virtual void StartSaving(BView *view);
	virtual void StopSaving();
	void loadBots();
	void addBot(Robot *r);
	void addShot(weapon &wp);
	void s_move(BPoint &, float direction, float speed);
	void s_move(BRect &, float direction, float speed);
	void collision(Robot *, Robot *);
	void collision(Robot *, weapon &);

	virtual double Save();
	string m_results;
	BRect arenaRect;
	BRect viewRect;
	BView *m_View;
	typedef list<Robot *, allocator<Robot *> > botlist;
	typedef list<weapon, allocator<weapon> > weplist;
	botlist m_Robots;
	weplist m_Weapons;
	int m_boom;
};

#pragma export on
extern "C" {
extern void	module_initialize(void *, long);
extern void	module_cleanup(void **, long *);
extern void	module_start_saving(BView *);
extern void	module_stop_saving();
extern void module_start_config(BView *);
extern void module_stop_config();
}
#pragma export reset


